// Created by Newton Book Maker 
// Document
book := {
	version: 2,
	isbn: "84875957",
	title: "Super Simple Story",
	shortTitle: "Super Simple",
	data: {},   // Authors own data
	contents: Array(6, NIL),
	styles: [], hints: Array(6, NIL),
	browsers: [], templates: [], rendering: []};
output.book := book;

// Shared Map Functions
func MakePage(aTemplate)
	{template: aTemplate, blocks: []};
func MakeBlock(aBounds, anItem)
	{bounds: aBounds, item: anItem};


func MyStuffHex(aString, aClass)
	if GlobalFnExists('MakeBinaryFromHex) then
		MakeBinaryFromHex(aString, aClass)
	else
		StuffHex(aString, aClass);
DeclareGlobalFn('MyStuffHex, 2);

// Shared Scripts
gotoDestScript := func() begin
	if (curRendering = 0) then :TurnToPage(destPage);
	else :TurnToPage(:FindPageByContent(kioskDest, 0, NIL));
end;

// Hints
book.hints[1] := TRUE;
book.hints[2] := TRUE;
book.hints[3] := TRUE;
book.hints[4] := TRUE;
book.hints[5] := TRUE;

// Text Styles
s0 := {
	family: 'Geneva,
	face: 0,
	size: 9};
AddArraySlot(book.styles, s0);

s1 := {
	family: 'Geneva,
	face: 0,
	size: 12};
AddArraySlot(book.styles, s1);


// Contents
c1 := {
	data: "Super Simple Story",
	layout: 2048
};
book.contents[0] := c1;

c2 := {
	data: "
This is one mega simple story.
",
	viewFont: s1
};
book.contents[1] := c2;

c3 := {
	data: "Chapter 1 The Guy

There once was a Guy.
",
	viewFont: s1
};
book.contents[2] := c3;

c4 := {
	data: "Chapter 2 The Lady

There once was also a lady.
",
	viewFont: s1
};
book.contents[3] := c4;

c5 := {
	data: "Chapter3 They Met

The two met and lived happily ever after.
",
	viewFont: s1
};
book.contents[4] := c5;

c6 := {
	data: "The End
",
	viewFont: s1
};
book.contents[5] := c6;


// Kiosk (menu page) references

// Page Templates
NBMDefault := {
	nColumns: 1,
	column: [{
	width: 12,
	type: 0}]
};
AddArraySlot(book.templates, NBMDefault);
default := {
	nColumns: 1,
	column: [{
	width: 12,
	type: 0}],
	flags: 8
};
AddArraySlot(book.templates, default);

// Bounds List
bnd1 := [0,0,240,48];
bnd2 := [0,48,240,112];
bnd3 := [0,112,240,176];
bnd4 := [0,176,240,256];
bnd5 := [0,256,240,288];

// Pages
pageList := {pageSize: {left: 0, top: 0, right: 240, bottom: 302},
	contents: [], pages: []};

// Page 1
page := MakePage(default);
AddArraySlot(page.blocks, MakeBlock(bnd1, c2));
AddArraySlot(page.blocks, MakeBlock(bnd2, c3));
AddArraySlot(page.blocks, MakeBlock(bnd3, c4));
AddArraySlot(page.blocks, MakeBlock(bnd4, c5));
AddArraySlot(page.blocks, MakeBlock(bnd5, c6));
AddArraySlot(pageList.pages, page);

AddArraySlot(book.rendering, pageList);

// Browsers & "Page Hints"
b1 := {
	name: "Contents",  list: []
};
bp1 := [];		// "Page Hints" for list browser

AddArraySlot(b1.list, {	// 0
	item: c1
});
AddArraySlot(bp1, 1);
AddArraySlot(b1.list, {	// 1
	item: c3
});
AddArraySlot(bp1, 1);
AddArraySlot(b1.list, {	// 2
	item: c4
});
AddArraySlot(bp1, 1);
AddArraySlot(b1.list, {	// 3
	item: c5
});
AddArraySlot(bp1, 1);
AddArraySlot(b1.list, {	// 4
	item: c6
});
AddArraySlot(bp1, 1);
AddArraySlot(book.browsers, b1);
AddArraySlot(pageList.contents, bp1);


// Indices and Sub-Indices

// Pages
pageList := {pageSize: {left: 0, top: 0, right: 298, bottom: 388},
	contents: [], pages: []};

// Page 1
page := MakePage(default);
AddArraySlot(page.blocks, MakeBlock(bnd1, c2));
AddArraySlot(page.blocks, MakeBlock(bnd2, c3));
AddArraySlot(page.blocks, MakeBlock(bnd3, c4));
AddArraySlot(page.blocks, MakeBlock(bnd4, c5));
AddArraySlot(page.blocks, MakeBlock(bnd5, c6));
AddArraySlot(pageList.pages, page);

AddArraySlot(book.rendering, pageList);

// Browsers & "Page Hints"
b1 := {
	name: "Contents",  list: []
};
bp1 := [];		// "Page Hints" for list browser

AddArraySlot(b1.list, {	// 0
	item: c1
});
AddArraySlot(bp1, 1);
AddArraySlot(b1.list, {	// 1
	item: c3
});
AddArraySlot(bp1, 1);
AddArraySlot(b1.list, {	// 2
	item: c4
});
AddArraySlot(bp1, 1);
AddArraySlot(b1.list, {	// 3
	item: c5
});
AddArraySlot(bp1, 1);
AddArraySlot(b1.list, {	// 4
	item: c6
});
AddArraySlot(bp1, 1);
AddArraySlot(book.browsers, b1);
AddArraySlot(pageList.contents, bp1);


// Indices and Sub-Indices

// Pages
pageList := {pageSize: {left: 0, top: 0, right: 414, bottom: 276},
	contents: [], pages: []};

// Page 1
page := MakePage(default);
AddArraySlot(page.blocks, MakeBlock(bnd1, c2));
AddArraySlot(page.blocks, MakeBlock(bnd2, c3));
AddArraySlot(page.blocks, MakeBlock(bnd3, c4));
AddArraySlot(page.blocks, MakeBlock(bnd4, c5));
AddArraySlot(page.blocks, MakeBlock(bnd5, c6));
AddArraySlot(pageList.pages, page);

AddArraySlot(book.rendering, pageList);

// Browsers & "Page Hints"
b1 := {
	name: "Contents",  list: []
};
bp1 := [];		// "Page Hints" for list browser

AddArraySlot(b1.list, {	// 0
	item: c1
});
AddArraySlot(bp1, 1);
AddArraySlot(b1.list, {	// 1
	item: c3
});
AddArraySlot(bp1, 1);
AddArraySlot(b1.list, {	// 2
	item: c4
});
AddArraySlot(bp1, 1);
AddArraySlot(b1.list, {	// 3
	item: c5
});
AddArraySlot(bp1, 1);
AddArraySlot(b1.list, {	// 4
	item: c6
});
AddArraySlot(bp1, 1);
AddArraySlot(book.browsers, b1);
AddArraySlot(pageList.contents, bp1);


// Indices and Sub-Indices
